//-----------------------------------------------------
//	DirectX eLXg`Tv
//	2010.03.04 TMO
//-----------------------------------------------------

#include "stdafx.h"
#include "Graphic.h"
#include "KeyDownCheck.h"

class MyApp
{
	//eNX`摜eLXgf[^
	CTexture	m_texture;
	TextGraphic m_text;
	
	//L[̓`FbN
	KeyDownChk	m_chkNumA;
	KeyDownChk	m_chkNumS;
	KeyDownChk	m_chkNumD;
	KeyDownChk	m_chkNumF;
	KeyDownChk	m_chkNumZ;
	KeyDownChk	m_chkNumX;
	KeyDownChk	m_chkNumC;

public:
	//TvAv̏
	void Init(HWND hWnd)
	{
		//DirectX
		CreateGraphic( hWnd );

		//wiF
		GetGraphic()->m_backColor = 0x22222222;

		//wi摜̍쐬
		m_texture.Load(TEXT(".\\image\\sakura.jpg"));

		//tHg̏
		LOGFONT	logFont;
		::ZeroMemory( &logFont, sizeof( logFont ) );
	    logFont.lfHeight = 20;	//tHgTCY
		logFont.lfWidth = 0;
		logFont.lfEscapement = 0;
		logFont.lfOrientation = 0;
		logFont.lfWeight = FW_EXTRABOLD;
		logFont.lfItalic = 0;
		logFont.lfUnderline = 0;
		logFont.lfStrikeOut = 0;
		logFont.lfCharSet   = SHIFTJIS_CHARSET;
		logFont.lfOutPrecision = OUT_TT_ONLY_PRECIS;
		logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
		logFont.lfQuality = PROOF_QUALITY;
		logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;

#ifdef UNICODE
		//wcscpy_s͕̑(z)(obt@TCYƃfobKIȂ肷)
		wcscpy_s( logFont.lfFaceName, LF_FACESIZE, _T("lr ") );
#else
		strcpy_s( logFont.lfFaceName, LF_FACESIZE, _T("lr ") );
#endif	
		
		//eLXg摜̍쐬
		m_text.Create(
			_T("\̃eXgvOłB\nrWAmx݂ɂĂ݂܂B\n")
			_T("ꕶƂɃeNX`ĕ`܂BwGA͂ݏoƐ܂ԂĂ܂B\n")
			_T("\n")
			_T("ZL[:\n")
			_T("XL[:\n")
			_T("CL[:E\n")
			_T("\n")
			_T("AL[:eLXgʏ`\n")
			_T("SL[:eLXg\n")
			_T("DL[:eLXgiȂȂ܂j\n")
			_T("\n")
			_T("FL[:FԂɂ\n")
			,50,50,640-50,480-50//eLXg̕`GA
			,logFont );


		//L[_E`FbN̓o^
		m_chkNumA.SetKey('A');
		m_chkNumS.SetKey('S');
		m_chkNumD.SetKey('D');
		m_chkNumF.SetKey('F');
		m_chkNumZ.SetKey('Z');
		m_chkNumX.SetKey('X');
		m_chkNumC.SetKey('C');

	}

	void Roop()
	{
		//L[͂ɂ鏈
		if ( m_chkNumA.Actioned() ) {
			m_text.SetTextAlpha(0xffffffff);
		} else
		if ( m_chkNumS.Actioned() ) {
			m_text.SetTextAlpha(0x88888888);
		} else
		if ( m_chkNumD.Actioned() ) {
			m_text.SetTextAlpha(0x00000000);
		} else
		if ( m_chkNumF.Actioned() ) {
			//̐F𔒂ōĂ̂ŁAAt@ȊÕrbgĐԂeLXgɂ邱Ƃł܂B
			m_text.SetTextAlpha(0xffff0000);
		} else
		if ( m_chkNumZ.Actioned() ) {
			m_text.SetTextAlign(TextAlign::AlignLeft);
		} else
		if ( m_chkNumX.Actioned() ) {
			m_text.SetTextAlign(TextAlign::AlignCenter);
		} else
		if ( m_chkNumC.Actioned() ) {
			m_text.SetTextAlign(TextAlign::AlignRight);
		}

		//ȍ~`揈------------

		GetGraphic()->ClearAndBegin();

		//wi`
		GetGraphic()->Draw( 0, 0, 640, 480, &m_texture, 0xffffffff );

		//wi𕔕IɈÂ邽߂ɔ̍`
		GetGraphic()->DrawColorRect(50,50,640-50, 480-50,0xaa000000);
	
		//eLXg`
		m_text.Draw();

		GetGraphic()->EndAndPresent();
	}

	//TvAv̉
	void Release()
	{
		//eNX`̉
		m_text.Release();

		//DirectX̉
		ReleaseGraphic();
	}

};
static MyApp myApp;

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_PAINT:
		//WM_PAINTł͕`悵܂B
		//ValidateRectgƎWM_PAINTĂ΂ȂȂBitXN[\̎j
		ValidateRect( hWnd, NULL );
		break;
	case WM_DESTROY:
		myApp.Release();//TvAv
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	MSG msg;
	
	//EBhENX̓o^
	WNDCLASSEX wcex;
	memset( &wcex, 0, sizeof(wcex) );
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= TEXT("wcDrawSample");

	if( !RegisterClassEx(&wcex) ) {
		return FALSE;
	}

	HWND hWnd;
	hWnd = CreateWindow(TEXT("wcDrawSample"), TEXT("`Tv"), WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
	CW_USEDEFAULT, 0, 640, 480, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}
	
	{
		//NCAgTCY640480ɂB
		//݃EBhETCY640480Ȃ̂ŃNCAgTCY擾Ęg^Cg߂
		RECT rect;
		GetClientRect( hWnd, &rect );
		int ofsW = 640 - ( rect.right - rect.left );
		int ofsH = 480 - ( rect.bottom - rect.top );
		SetWindowPos( hWnd, NULL, 0, 0, 640+ofsW, 480+ofsH, SWP_NOMOVE | SWP_NOZORDER );
	}

	//TvAv̏
	myApp.Init(hWnd);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	for (;;) {
		if ( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) {
			
			if ( GetMessage( &msg, NULL, 0, 0 ) > 0) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			} else {
				break;
			}

		} else {
			//Q[̏ł
			myApp.Roop();
		}
	}

	return (int) msg.wParam;
}
